#ifndef DOM_BINDINGNAMES_H_
#define DOM_BINDINGNAMES_H_

#include <stddef.h>
#include <stdint.h>
#include "mozilla/Attributes.h"

namespace mozilla::dom {

enum class BindingNamesOffset : uint16_t {
  ANGLE_instanced_arrays = 0,
  APZHitResultFlags = 23,
  AbortController = 41,
  AbortSignal = 57,
  AbstractRange = 69,
  AccessibleNode = 83,
  Addon = 98,
  AddonEvent = 104,
  AddonInstall = 115,
  AddonManager = 128,
  AddonManagerPermissions = 141,
  AnalyserNode = 165,
  Animation = 178,
  AnimationEffect = 188,
  AnimationEvent = 204,
  AnimationPlaybackEvent = 219,
  AnimationTimeline = 242,
  AnonymousContent = 260,
  Attr = 277,
  Audio = 282,
  AudioBuffer = 288,
  AudioBufferSourceNode = 300,
  AudioContext = 322,
  AudioDestinationNode = 335,
  AudioListener = 356,
  AudioNode = 370,
  AudioParam = 380,
  AudioParamMap = 391,
  AudioProcessingEvent = 405,
  AudioScheduledSourceNode = 426,
  AudioTrack = 451,
  AudioTrackList = 462,
  AudioWorklet = 477,
  AudioWorkletGlobalScope = 490,
  AudioWorkletNode = 514,
  AudioWorkletProcessor = 531,
  AuthenticatorAssertionResponse = 553,
  AuthenticatorAttestationResponse = 584,
  AuthenticatorResponse = 617,
  BarProp = 639,
  BaseAudioContext = 647,
  BatteryManager = 664,
  BeforeUnloadEvent = 679,
  BiquadFilterNode = 697,
  Blob = 714,
  BlobEvent = 719,
  BroadcastChannel = 729,
  BrowsingContext = 746,
  BrowsingContextGroup = 762,
  ByteLengthQueuingStrategy = 783,
  CDATASection = 809,
  CSS = 822,
  CSS2Properties = 826,
  CSSAnimation = 841,
  CSSConditionRule = 854,
  CSSContainerRule = 871,
  CSSCounterStyleRule = 888,
  CSSCustomPropertyRegisteredEvent = 908,
  CSSFontFaceRule = 941,
  CSSFontFeatureValuesRule = 957,
  CSSFontPaletteValuesRule = 982,
  CSSGroupingRule = 1007,
  CSSImportRule = 1023,
  CSSKeyframeRule = 1037,
  CSSKeyframesRule = 1053,
  CSSLayerBlockRule = 1070,
  CSSLayerStatementRule = 1088,
  CSSMediaRule = 1110,
  CSSMozDocumentRule = 1123,
  CSSNamespaceRule = 1142,
  CSSPageRule = 1159,
  CSSPropertyRule = 1171,
  CSSPseudoElement = 1187,
  CSSRule = 1204,
  CSSRuleList = 1212,
  CSSStyleDeclaration = 1224,
  CSSStyleRule = 1244,
  CSSStyleSheet = 1257,
  CSSSupportsRule = 1271,
  CSSTransition = 1287,
  Cache = 1301,
  CacheStorage = 1307,
  CallbackDebuggerNotification = 1320,
  CanonicalBrowsingContext = 1349,
  CanvasCaptureMediaStream = 1374,
  CanvasGradient = 1399,
  CanvasPattern = 1414,
  CanvasRenderingContext2D = 1428,
  CaretPosition = 1453,
  CaretStateChangedEvent = 1467,
  ChannelMergerNode = 1490,
  ChannelSplitterNode = 1508,
  ChannelWrapper = 1528,
  CharacterData = 1543,
  CheckerboardReportService = 1557,
  ChildProcessMessageManager = 1583,
  ChildSHistory = 1610,
  ChromeMessageBroadcaster = 1624,
  ChromeMessageSender = 1649,
  ChromeNodeList = 1669,
  ChromeUtils = 1684,
  ChromeWorker = 1696,
  Client = 1709,
  Clients = 1716,
  Clipboard = 1724,
  ClipboardEvent = 1734,
  ClipboardItem = 1749,
  ClonedErrorHolder = 1763,
  CloseEvent = 1781,
  CommandEvent = 1792,
  Comment = 1805,
  CompositionEvent = 1813,
  CompressionStream = 1830,
  ConsoleInstance = 1848,
  ConstantSourceNode = 1864,
  ContentFrameMessageManager = 1883,
  ContentProcessMessageManager = 1910,
  ContentVisibilityAutoStateChangeEvent = 1939,
  ConvolverNode = 1977,
  CountQueuingStrategy = 1991,
  CreateOfferRequest = 2012,
  Credential = 2031,
  CredentialsContainer = 2042,
  Crypto = 2063,
  CryptoKey = 2070,
  CustomElementRegistry = 2080,
  CustomEvent = 2102,
  CustomStateSet = 2114,
  DOMException = 2129,
  DOMImplementation = 2142,
  DOMLocalization = 2160,
  DOMMatrix = 2176,
  DOMMatrixReadOnly = 2186,
  DOMParser = 2204,
  DOMPoint = 2214,
  DOMPointReadOnly = 2223,
  DOMQuad = 2240,
  DOMRect = 2248,
  DOMRectList = 2256,
  DOMRectReadOnly = 2268,
  DOMRequest = 2284,
  DOMStringList = 2295,
  DOMStringMap = 2309,
  DOMTokenList = 2322,
  DataTransfer = 2335,
  DataTransferItem = 2348,
  DataTransferItemList = 2365,
  DebuggerNotification = 2386,
  DebuggerNotificationObserver = 2407,
  DecompressionStream = 2436,
  DedicatedWorkerGlobalScope = 2456,
  DelayNode = 2483,
  DeprecationReportBody = 2493,
  DeviceAcceleration = 2515,
  DeviceLightEvent = 2534,
  DeviceMotionEvent = 2551,
  DeviceOrientationEvent = 2569,
  DeviceRotationRate = 2592,
  Directory = 2611,
  Document = 2621,
  DocumentFragment = 2630,
  DocumentL10n = 2647,
  DocumentTimeline = 2660,
  DocumentType = 2677,
  DominatorTree = 2690,
  DragEvent = 2704,
  DynamicsCompressorNode = 2714,
  EXT_blend_minmax = 2737,
  EXT_color_buffer_float = 2754,
  EXT_color_buffer_half_float = 2777,
  EXT_disjoint_timer_query = 2805,
  EXT_float_blend = 2830,
  EXT_frag_depth = 2846,
  EXT_sRGB = 2861,
  EXT_shader_texture_lod = 2870,
  EXT_texture_compression_bptc = 2893,
  EXT_texture_compression_rgtc = 2922,
  EXT_texture_filter_anisotropic = 2951,
  EXT_texture_norm16 = 2982,
  Element = 3001,
  ElementInternals = 3009,
  EncodedVideoChunk = 3026,
  ErrorEvent = 3044,
  Event = 3055,
  EventCallbackDebuggerNotification = 3061,
  EventCounts = 3095,
  EventSource = 3107,
  EventTarget = 3119,
  Exception = 3131,
  ExtendableEvent = 3141,
  ExtendableMessageEvent = 3157,
  ExtensionAlarms = 3180,
  ExtensionBrowser = 3196,
  ExtensionBrowserSettings = 3213,
  ExtensionBrowserSettingsColorManagement = 3238,
  ExtensionDns = 3278,
  ExtensionEventManager = 3291,
  ExtensionMockAPI = 3313,
  ExtensionPort = 3330,
  ExtensionProxy = 3344,
  ExtensionRuntime = 3359,
  ExtensionScripting = 3376,
  ExtensionSetting = 3395,
  ExtensionTest = 3412,
  External = 3426,
  FeaturePolicy = 3435,
  FeaturePolicyViolationReportBody = 3449,
  FetchEvent = 3482,
  FetchObserver = 3493,
  File = 3507,
  FileList = 3512,
  FileReader = 3521,
  FileReaderSync = 3532,
  FileSystem = 3547,
  FileSystemDirectoryEntry = 3558,
  FileSystemDirectoryHandle = 3583,
  FileSystemDirectoryHandle_AsyncIterator = 3609,
  FileSystemDirectoryIterator = 3649,
  FileSystemDirectoryReader = 3677,
  FileSystemEntry = 3703,
  FileSystemFileEntry = 3719,
  FileSystemFileHandle = 3739,
  FileSystemHandle = 3760,
  FileSystemSyncAccessHandle = 3777,
  FileSystemWritableFileStream = 3804,
  Flex = 3833,
  FlexItemValues = 3838,
  FlexLineValues = 3853,
  FluentBundle = 3868,
  FluentBundleAsyncIterator = 3881,
  FluentBundleIterator = 3907,
  FluentPattern = 3928,
  FluentResource = 3942,
  FocusEvent = 3957,
  FontFace = 3968,
  FontFaceSet = 3977,
  FontFaceSetIterator = 3989,
  FontFaceSetLoadEvent = 4009,
  FormData = 4030,
  FormData_Iterator = 4039,
  FormDataEvent = 4057,
  FrameCrashedEvent = 4071,
  FrameLoader = 4089,
  GPU = 4101,
  GPUAdapter = 4105,
  GPUAdapterInfo = 4116,
  GPUBindGroup = 4131,
  GPUBindGroupLayout = 4144,
  GPUBuffer = 4163,
  GPUBufferUsage = 4173,
  GPUCanvasContext = 4188,
  GPUColorWrite = 4205,
  GPUCommandBuffer = 4219,
  GPUCommandEncoder = 4236,
  GPUCompilationInfo = 4254,
  GPUCompilationMessage = 4273,
  GPUComputePassEncoder = 4295,
  GPUComputePipeline = 4317,
  GPUDevice = 4336,
  GPUDeviceLostInfo = 4346,
  GPUError = 4364,
  GPUInternalError = 4373,
  GPUMapMode = 4390,
  GPUOutOfMemoryError = 4401,
  GPUPipelineLayout = 4421,
  GPUQuerySet = 4439,
  GPUQueue = 4451,
  GPURenderBundle = 4460,
  GPURenderBundleEncoder = 4476,
  GPURenderPassEncoder = 4499,
  GPURenderPipeline = 4520,
  GPUSampler = 4538,
  GPUShaderModule = 4549,
  GPUShaderStage = 4565,
  GPUSupportedFeatures = 4580,
  GPUSupportedLimits = 4601,
  GPUTexture = 4620,
  GPUTextureUsage = 4631,
  GPUTextureView = 4647,
  GPUUncapturedErrorEvent = 4662,
  GPUValidationError = 4686,
  GainNode = 4705,
  Gamepad = 4714,
  GamepadAxisMoveEvent = 4722,
  GamepadButton = 4743,
  GamepadButtonEvent = 4757,
  GamepadEvent = 4776,
  GamepadHapticActuator = 4789,
  GamepadLightIndicator = 4811,
  GamepadPose = 4833,
  GamepadServiceTest = 4845,
  GamepadTouch = 4864,
  Geolocation = 4877,
  GeolocationCoordinates = 4889,
  GeolocationPosition = 4912,
  GeolocationPositionError = 4932,
  GetUserMediaRequest = 4957,
  GleanBoolean = 4977,
  GleanCategory = 4990,
  GleanCounter = 5004,
  GleanCustomDistribution = 5017,
  GleanDatetime = 5041,
  GleanDenominator = 5055,
  GleanEvent = 5072,
  GleanImpl = 5083,
  GleanLabeled = 5093,
  GleanMemoryDistribution = 5106,
  GleanMetric = 5130,
  GleanNumerator = 5142,
  GleanPingsImpl = 5157,
  GleanQuantity = 5172,
  GleanRate = 5186,
  GleanString = 5196,
  GleanStringList = 5208,
  GleanText = 5224,
  GleanTimespan = 5234,
  GleanTimingDistribution = 5248,
  GleanUrl = 5272,
  GleanUuid = 5281,
  Grid = 5291,
  GridArea = 5296,
  GridDimension = 5305,
  GridLine = 5319,
  GridLines = 5328,
  GridTrack = 5338,
  GridTracks = 5348,
  HTMLAllCollection = 5359,
  HTMLAnchorElement = 5377,
  HTMLAreaElement = 5395,
  HTMLAudioElement = 5411,
  HTMLBRElement = 5428,
  HTMLBaseElement = 5442,
  HTMLBodyElement = 5458,
  HTMLButtonElement = 5474,
  HTMLCanvasElement = 5492,
  HTMLCollection = 5510,
  HTMLDListElement = 5525,
  HTMLDataElement = 5542,
  HTMLDataListElement = 5558,
  HTMLDetailsElement = 5578,
  HTMLDialogElement = 5597,
  HTMLDirectoryElement = 5615,
  HTMLDivElement = 5636,
  HTMLDocument = 5651,
  HTMLElement = 5664,
  HTMLEmbedElement = 5676,
  HTMLFieldSetElement = 5693,
  HTMLFontElement = 5713,
  HTMLFormControlsCollection = 5729,
  HTMLFormElement = 5756,
  HTMLFrameElement = 5772,
  HTMLFrameSetElement = 5789,
  HTMLHRElement = 5809,
  HTMLHeadElement = 5823,
  HTMLHeadingElement = 5839,
  HTMLHtmlElement = 5858,
  HTMLIFrameElement = 5874,
  HTMLImageElement = 5892,
  HTMLInputElement = 5909,
  HTMLLIElement = 5926,
  HTMLLabelElement = 5940,
  HTMLLegendElement = 5957,
  HTMLLinkElement = 5975,
  HTMLMapElement = 5991,
  HTMLMarqueeElement = 6006,
  HTMLMediaElement = 6025,
  HTMLMenuElement = 6042,
  HTMLMetaElement = 6058,
  HTMLMeterElement = 6074,
  HTMLModElement = 6091,
  HTMLOListElement = 6106,
  HTMLObjectElement = 6123,
  HTMLOptGroupElement = 6141,
  HTMLOptionElement = 6161,
  HTMLOptionsCollection = 6179,
  HTMLOutputElement = 6201,
  HTMLParagraphElement = 6219,
  HTMLParamElement = 6240,
  HTMLPictureElement = 6257,
  HTMLPreElement = 6276,
  HTMLProgressElement = 6291,
  HTMLQuoteElement = 6311,
  HTMLScriptElement = 6328,
  HTMLSelectElement = 6346,
  HTMLSlotElement = 6364,
  HTMLSourceElement = 6380,
  HTMLSpanElement = 6398,
  HTMLStyleElement = 6414,
  HTMLTableCaptionElement = 6431,
  HTMLTableCellElement = 6455,
  HTMLTableColElement = 6476,
  HTMLTableElement = 6496,
  HTMLTableRowElement = 6513,
  HTMLTableSectionElement = 6533,
  HTMLTemplateElement = 6557,
  HTMLTextAreaElement = 6577,
  HTMLTimeElement = 6597,
  HTMLTitleElement = 6613,
  HTMLTrackElement = 6630,
  HTMLUListElement = 6647,
  HTMLUnknownElement = 6664,
  HTMLVideoElement = 6683,
  HashChangeEvent = 6700,
  Headers = 6716,
  Headers_Iterator = 6724,
  HeapSnapshot = 6741,
  Highlight = 6754,
  HighlightRegistry = 6764,
  History = 6782,
  IDBCursor = 6790,
  IDBCursorWithValue = 6800,
  IDBDatabase = 6819,
  IDBFactory = 6831,
  IDBIndex = 6842,
  IDBKeyRange = 6851,
  IDBObjectStore = 6863,
  IDBOpenDBRequest = 6878,
  IDBRequest = 6895,
  IDBTransaction = 6906,
  IDBVersionChangeEvent = 6921,
  IIRFilterNode = 6943,
  IOUtils = 6957,
  IdentityCredential = 6965,
  IdleDeadline = 6984,
  Image = 6997,
  ImageBitmap = 7003,
  ImageBitmapRenderingContext = 7015,
  ImageCapture = 7043,
  ImageCaptureError = 7056,
  ImageCaptureErrorEvent = 7074,
  ImageData = 7097,
  ImageDocument = 7107,
  InputEvent = 7121,
  InspectorFontFace = 7132,
  InspectorUtils = 7150,
  InstallTriggerImpl = 7165,
  IntersectionObserver = 7184,
  IntersectionObserverEntry = 7205,
  IntlUtils = 7231,
  InvokeEvent = 7241,
  JSProcessActorChild = 7253,
  JSProcessActorParent = 7273,
  JSWindowActorChild = 7294,
  JSWindowActorParent = 7313,
  KeyEvent = 7333,
  KeyboardEvent = 7342,
  KeyframeEffect = 7356,
  L10nFileSource = 7371,
  L10nOverlays = 7386,
  L10nRegistry = 7399,
  LargestContentfulPaint = 7412,
  LegacyMozTCPSocket = 7435,
  Localization = 7454,
  Location = 7467,
  Lock = 7476,
  LockManager = 7481,
  MIDIAccess = 7493,
  MIDIConnectionEvent = 7504,
  MIDIInput = 7524,
  MIDIInputMap = 7534,
  MIDIMessageEvent = 7547,
  MIDIOutput = 7564,
  MIDIOutputMap = 7575,
  MIDIPort = 7589,
  MOZ_debug = 7598,
  MatchGlob = 7608,
  MatchPattern = 7618,
  MatchPatternSet = 7631,
  MathMLElement = 7647,
  MediaCapabilities = 7661,
  MediaCapabilitiesInfo = 7679,
  MediaControlService = 7701,
  MediaController = 7721,
  MediaDeviceInfo = 7737,
  MediaDevices = 7753,
  MediaElementAudioSourceNode = 7766,
  MediaEncryptedEvent = 7794,
  MediaError = 7814,
  MediaKeyError = 7825,
  MediaKeyMessageEvent = 7839,
  MediaKeySession = 7860,
  MediaKeyStatusMap = 7876,
  MediaKeyStatusMap_Iterator = 7894,
  MediaKeySystemAccess = 7921,
  MediaKeys = 7942,
  MediaList = 7952,
  MediaMetadata = 7962,
  MediaQueryList = 7976,
  MediaQueryListEvent = 7991,
  MediaRecorder = 8011,
  MediaRecorderErrorEvent = 8025,
  MediaSession = 8049,
  MediaSource = 8062,
  MediaStream = 8074,
  MediaStreamAudioDestinationNode = 8086,
  MediaStreamAudioSourceNode = 8118,
  MediaStreamError = 8145,
  MediaStreamEvent = 8162,
  MediaStreamTrack = 8179,
  MediaStreamTrackAudioSourceNode = 8196,
  MediaStreamTrackEvent = 8228,
  MerchantValidationEvent = 8250,
  MessageBroadcaster = 8274,
  MessageChannel = 8293,
  MessageEvent = 8308,
  MessageListenerManager = 8321,
  MessagePort = 8344,
  MessageSender = 8356,
  MimeType = 8370,
  MimeTypeArray = 8379,
  MouseEvent = 8393,
  MouseScrollEvent = 8404,
  MozCanvasPrintState = 8421,
  MozDocumentMatcher = 8441,
  MozDocumentObserver = 8460,
  MozQueryInterface = 8480,
  MozSharedMap = 8498,
  MozSharedMap_Iterator = 8511,
  MozSharedMapChangeEvent = 8533,
  MozStorageAsyncStatementParams = 8557,
  MozStorageStatementParams = 8588,
  MozStorageStatementRow = 8614,
  MozWritableSharedMap = 8637,
  MutationEvent = 8658,
  MutationObserver = 8672,
  MutationRecord = 8689,
  NamedNodeMap = 8704,
  NavigationPreloadManager = 8717,
  Navigator = 8742,
  NetworkInformation = 8752,
  Node = 8771,
  NodeFilter = 8776,
  NodeIterator = 8787,
  NodeList = 8800,
  Notification = 8809,
  NotificationEvent = 8822,
  NotifyPaintEvent = 8840,
  OES_draw_buffers_indexed = 8857,
  OES_element_index_uint = 8882,
  OES_fbo_render_mipmap = 8905,
  OES_standard_derivatives = 8927,
  OES_texture_float = 8952,
  OES_texture_float_linear = 8970,
  OES_texture_half_float = 8995,
  OES_texture_half_float_linear = 9018,
  OES_vertex_array_object = 9048,
  OVR_multiview2 = 9072,
  OfflineAudioCompletionEvent = 9087,
  OfflineAudioContext = 9115,
  OffscreenCanvas = 9135,
  OffscreenCanvasRenderingContext2D = 9151,
  OnlyForUseInConstructor = 9185,
  Option = 9209,
  OscillatorNode = 9216,
  PageTransitionEvent = 9231,
  PaintRequest = 9251,
  PaintRequestList = 9264,
  PaintWorkletGlobalScope = 9281,
  PannerNode = 9305,
  ParentProcessMessageManager = 9316,
  Path2D = 9344,
  PathUtils = 9351,
  PaymentAddress = 9361,
  PaymentMethodChangeEvent = 9376,
  PaymentRequest = 9401,
  PaymentRequestUpdateEvent = 9416,
  PaymentResponse = 9442,
  PeerConnectionImpl = 9458,
  PeerConnectionObserver = 9477,
  Performance = 9500,
  PerformanceEntry = 9512,
  PerformanceEntryEvent = 9529,
  PerformanceEventTiming = 9551,
  PerformanceMark = 9574,
  PerformanceMeasure = 9590,
  PerformanceNavigation = 9609,
  PerformanceNavigationTiming = 9631,
  PerformanceObserver = 9659,
  PerformanceObserverEntryList = 9679,
  PerformancePaintTiming = 9708,
  PerformanceResourceTiming = 9731,
  PerformanceServerTiming = 9757,
  PerformanceTiming = 9781,
  PeriodicWave = 9799,
  PermissionStatus = 9812,
  Permissions = 9829,
  PlacesBookmark = 9841,
  PlacesBookmarkAddition = 9856,
  PlacesBookmarkChanged = 9879,
  PlacesBookmarkGuid = 9901,
  PlacesBookmarkKeyword = 9920,
  PlacesBookmarkMoved = 9942,
  PlacesBookmarkRemoved = 9962,
  PlacesBookmarkTags = 9984,
  PlacesBookmarkTime = 10003,
  PlacesBookmarkTitle = 10022,
  PlacesBookmarkUrl = 10042,
  PlacesEvent = 10060,
  PlacesFavicon = 10072,
  PlacesHistoryCleared = 10086,
  PlacesObservers = 10107,
  PlacesPurgeCaches = 10123,
  PlacesRanking = 10141,
  PlacesVisit = 10155,
  PlacesVisitRemoved = 10167,
  PlacesVisitTitle = 10186,
  PlacesWeakCallbackWrapper = 10203,
  Plugin = 10229,
  PluginArray = 10236,
  PluginCrashedEvent = 10248,
  PointerEvent = 10267,
  PopStateEvent = 10280,
  PopupBlockedEvent = 10294,
  PopupPositionedEvent = 10312,
  PositionStateEvent = 10333,
  PrecompiledScript = 10352,
  ProcessMessageManager = 10370,
  ProcessingInstruction = 10392,
  ProgressEvent = 10414,
  PromiseDebugging = 10428,
  PromiseNativeHandler = 10445,
  PromiseRejectionEvent = 10466,
  PublicKeyCredential = 10488,
  PushEvent = 10508,
  PushManager = 10518,
  PushManagerImpl = 10530,
  PushMessageData = 10546,
  PushSubscription = 10562,
  PushSubscriptionOptions = 10579,
  RTCCertificate = 10603,
  RTCDTMFSender = 10618,
  RTCDTMFToneChangeEvent = 10632,
  RTCDataChannel = 10655,
  RTCDataChannelEvent = 10670,
  RTCDtlsTransport = 10690,
  RTCEncodedAudioFrame = 10707,
  RTCEncodedVideoFrame = 10728,
  RTCIceCandidate = 10749,
  RTCIdentityProviderRegistrar = 10765,
  RTCPeerConnection = 10794,
  RTCPeerConnectionIceEvent = 10812,
  RTCPeerConnectionStatic = 10838,
  RTCRtpReceiver = 10862,
  RTCRtpScriptTransform = 10877,
  RTCRtpScriptTransformer = 10899,
  RTCRtpSender = 10923,
  RTCRtpTransceiver = 10936,
  RTCSctpTransport = 10954,
  RTCSessionDescription = 10971,
  RTCStatsReport = 10993,
  RTCTrackEvent = 11008,
  RTCTransformEvent = 11022,
  RadioNodeList = 11040,
  Range = 11054,
  ReadableByteStreamController = 11060,
  ReadableStream = 11089,
  ReadableStream_AsyncIterator = 11104,
  ReadableStreamBYOBReader = 11133,
  ReadableStreamBYOBRequest = 11158,
  ReadableStreamDefaultController = 11184,
  ReadableStreamDefaultReader = 11216,
  Report = 11244,
  ReportBody = 11251,
  ReportingObserver = 11262,
  Request = 11280,
  ResizeObserver = 11288,
  ResizeObserverEntry = 11303,
  ResizeObserverSize = 11323,
  Response = 11342,
  SVGAElement = 11351,
  SVGAngle = 11363,
  SVGAnimateElement = 11372,
  SVGAnimateMotionElement = 11390,
  SVGAnimateTransformElement = 11414,
  SVGAnimatedAngle = 11441,
  SVGAnimatedBoolean = 11458,
  SVGAnimatedEnumeration = 11477,
  SVGAnimatedInteger = 11500,
  SVGAnimatedLength = 11519,
  SVGAnimatedLengthList = 11537,
  SVGAnimatedNumber = 11559,
  SVGAnimatedNumberList = 11577,
  SVGAnimatedPreserveAspectRatio = 11599,
  SVGAnimatedRect = 11630,
  SVGAnimatedString = 11646,
  SVGAnimatedTransformList = 11664,
  SVGAnimationElement = 11689,
  SVGCircleElement = 11709,
  SVGClipPathElement = 11726,
  SVGComponentTransferFunctionElement = 11745,
  SVGDefsElement = 11781,
  SVGDescElement = 11796,
  SVGElement = 11811,
  SVGEllipseElement = 11822,
  SVGFEBlendElement = 11840,
  SVGFEColorMatrixElement = 11858,
  SVGFEComponentTransferElement = 11882,
  SVGFECompositeElement = 11912,
  SVGFEConvolveMatrixElement = 11934,
  SVGFEDiffuseLightingElement = 11961,
  SVGFEDisplacementMapElement = 11989,
  SVGFEDistantLightElement = 12017,
  SVGFEDropShadowElement = 12042,
  SVGFEFloodElement = 12065,
  SVGFEFuncAElement = 12083,
  SVGFEFuncBElement = 12101,
  SVGFEFuncGElement = 12119,
  SVGFEFuncRElement = 12137,
  SVGFEGaussianBlurElement = 12155,
  SVGFEImageElement = 12180,
  SVGFEMergeElement = 12198,
  SVGFEMergeNodeElement = 12216,
  SVGFEMorphologyElement = 12238,
  SVGFEOffsetElement = 12261,
  SVGFEPointLightElement = 12280,
  SVGFESpecularLightingElement = 12303,
  SVGFESpotLightElement = 12332,
  SVGFETileElement = 12354,
  SVGFETurbulenceElement = 12371,
  SVGFilterElement = 12394,
  SVGForeignObjectElement = 12411,
  SVGGElement = 12435,
  SVGGeometryElement = 12447,
  SVGGradientElement = 12466,
  SVGGraphicsElement = 12485,
  SVGImageElement = 12504,
  SVGLength = 12520,
  SVGLengthList = 12530,
  SVGLineElement = 12544,
  SVGLinearGradientElement = 12559,
  SVGMPathElement = 12584,
  SVGMarkerElement = 12600,
  SVGMaskElement = 12617,
  SVGMatrix = 12632,
  SVGMetadataElement = 12642,
  SVGNumber = 12661,
  SVGNumberList = 12671,
  SVGPathElement = 12685,
  SVGPathSeg = 12700,
  SVGPathSegArcAbs = 12711,
  SVGPathSegArcRel = 12728,
  SVGPathSegClosePath = 12745,
  SVGPathSegCurvetoCubicAbs = 12765,
  SVGPathSegCurvetoCubicRel = 12791,
  SVGPathSegCurvetoCubicSmoothAbs = 12817,
  SVGPathSegCurvetoCubicSmoothRel = 12849,
  SVGPathSegCurvetoQuadraticAbs = 12881,
  SVGPathSegCurvetoQuadraticRel = 12911,
  SVGPathSegCurvetoQuadraticSmoothAbs = 12941,
  SVGPathSegCurvetoQuadraticSmoothRel = 12977,
  SVGPathSegLinetoAbs = 13013,
  SVGPathSegLinetoHorizontalAbs = 13033,
  SVGPathSegLinetoHorizontalRel = 13063,
  SVGPathSegLinetoRel = 13093,
  SVGPathSegLinetoVerticalAbs = 13113,
  SVGPathSegLinetoVerticalRel = 13141,
  SVGPathSegList = 13169,
  SVGPathSegMovetoAbs = 13184,
  SVGPathSegMovetoRel = 13204,
  SVGPatternElement = 13224,
  SVGPoint = 13242,
  SVGPointList = 13251,
  SVGPolygonElement = 13264,
  SVGPolylineElement = 13282,
  SVGPreserveAspectRatio = 13301,
  SVGRadialGradientElement = 13324,
  SVGRect = 13349,
  SVGRectElement = 13357,
  SVGSVGElement = 13372,
  SVGScriptElement = 13386,
  SVGSetElement = 13403,
  SVGStopElement = 13417,
  SVGStringList = 13432,
  SVGStyleElement = 13446,
  SVGSwitchElement = 13462,
  SVGSymbolElement = 13479,
  SVGTSpanElement = 13496,
  SVGTextContentElement = 13512,
  SVGTextElement = 13534,
  SVGTextPathElement = 13549,
  SVGTextPositioningElement = 13568,
  SVGTitleElement = 13594,
  SVGTransform = 13610,
  SVGTransformList = 13623,
  SVGUnitTypes = 13640,
  SVGUseElement = 13653,
  SVGViewElement = 13667,
  Sanitizer = 13682,
  Scheduler = 13692,
  Screen = 13702,
  ScreenLuminance = 13709,
  ScreenOrientation = 13725,
  ScriptProcessorNode = 13743,
  ScrollAreaEvent = 13763,
  ScrollViewChangeEvent = 13779,
  SecurityPolicyViolationEvent = 13801,
  Selection = 13830,
  ServiceWorker = 13840,
  ServiceWorkerContainer = 13854,
  ServiceWorkerGlobalScope = 13877,
  ServiceWorkerRegistration = 13902,
  SessionStoreFormData = 13928,
  SessionStoreScrollData = 13949,
  SessionStoreUtils = 13972,
  ShadowRealmGlobalScope = 13990,
  ShadowRoot = 14013,
  SharedWorker = 14024,
  SharedWorkerGlobalScope = 14037,
  SimpleGestureEvent = 14061,
  SourceBuffer = 14080,
  SourceBufferList = 14093,
  SpeechGrammar = 14110,
  SpeechGrammarList = 14124,
  SpeechRecognition = 14142,
  SpeechRecognitionAlternative = 14160,
  SpeechRecognitionError = 14189,
  SpeechRecognitionEvent = 14212,
  SpeechRecognitionResult = 14235,
  SpeechRecognitionResultList = 14259,
  SpeechSynthesis = 14287,
  SpeechSynthesisErrorEvent = 14303,
  SpeechSynthesisEvent = 14329,
  SpeechSynthesisUtterance = 14350,
  SpeechSynthesisVoice = 14375,
  StaticRange = 14396,
  StereoPannerNode = 14408,
  Storage = 14425,
  StorageEvent = 14433,
  StorageManager = 14446,
  StreamFilter = 14461,
  StreamFilterDataEvent = 14474,
  StructuredCloneHolder = 14496,
  StructuredCloneTester = 14518,
  StyleSheet = 14540,
  StyleSheetApplicableStateChangeEvent = 14551,
  StyleSheetList = 14588,
  StyleSheetRemovedEvent = 14603,
  SubmitEvent = 14626,
  SubtleCrypto = 14638,
  SyncMessageSender = 14651,
  SyncReadFile = 14669,
  TCPServerSocket = 14682,
  TCPServerSocketEvent = 14698,
  TCPSocket = 14719,
  TCPSocketErrorEvent = 14729,
  TCPSocketEvent = 14749,
  TaskController = 14764,
  TaskPriorityChangeEvent = 14779,
  TaskSignal = 14803,
  TelemetryStopwatch = 14814,
  TestAttributesOnTypes = 14833,
  TestCEReactionsInterface = 14855,
  TestCImplementedInterface = 14880,
  TestCImplementedInterface2 = 14906,
  TestChildInterface = 14933,
  TestConstructorForFuncInterface = 14952,
  TestConstructorForPrefInterface = 14984,
  TestConstructorForSCInterface = 15016,
  TestCppKeywordNamedMethodsInterface = 15046,
  TestDeprecatedInterface = 15082,
  TestExampleInterface = 15106,
  TestExampleProxyInterface = 15127,
  TestExampleThrowingConstructorInterface = 15153,
  TestExampleWorkerInterface = 15193,
  TestFuncConstructorForDifferentFuncInterface = 15220,
  TestFuncConstructorForInterface = 15265,
  TestHTMLConstructorInterface = 15297,
  TestIndexedAndNamedGetterAndSetterInterface = 15326,
  TestIndexedAndNamedGetterInterface = 15370,
  TestIndexedAndNamedSetterInterface = 15405,
  TestIndexedGetterAndSetterAndNamedGetterInterface = 15440,
  TestIndexedGetterInterface = 15490,
  TestIndexedSetterInterface = 15517,
  TestInterface = 15544,
  TestInterfaceWithPromiseConstructorArg = 15558,
  TestJSImplInterface = 15597,
  TestJSImplInterface2 = 15617,
  TestJSImplInterface3 = 15638,
  TestJSImplInterface4 = 15659,
  TestJSImplInterface5 = 15680,
  TestJSImplInterface6 = 15701,
  TestJSImplNoInterfaceObject = 15722,
  TestNamedDeleterInterface = 15750,
  TestNamedDeleterWithRetvalInterface = 15776,
  TestNamedGetterInterface = 15812,
  TestNamedSetterInterface = 15837,
  TestNamespace = 15862,
  TestNonWrapperCacheInterface = 15876,
  TestParentInterface = 15905,
  TestPrefChromeOnlySCFuncConstructorForInterface = 15925,
  TestPrefConstructorForDifferentPrefInterface = 15973,
  TestPrefConstructorForInterface = 16018,
  TestProtoObjectHackedNamespace = 16050,
  TestRenamedInterface = 16081,
  TestRenamedNamespace = 16102,
  TestSCConstructorForInterface = 16123,
  TestSecureContextInterface = 16153,
  TestThrowingConstructorInterface = 16180,
  TestUtils = 16213,
  TestWorkerExposedInterface = 16223,
  TestingDeprecatedInterface = 16250,
  Text = 16277,
  TextClause = 16282,
  TextDecoder = 16293,
  TextDecoderStream = 16305,
  TextEncoder = 16323,
  TextEncoderStream = 16335,
  TextMetrics = 16353,
  TextTrack = 16365,
  TextTrackCue = 16375,
  TextTrackCueList = 16388,
  TextTrackList = 16405,
  TimeEvent = 16419,
  TimeRanges = 16429,
  ToggleEvent = 16440,
  Touch = 16452,
  TouchEvent = 16458,
  TouchList = 16469,
  TrackEvent = 16479,
  TransformStream = 16490,
  TransformStreamDefaultController = 16506,
  TransitionEvent = 16539,
  TreeColumn = 16555,
  TreeColumns = 16566,
  TreeContentView = 16578,
  TreeWalker = 16594,
  UDPMessageEvent = 16605,
  UDPSocket = 16621,
  UIEvent = 16631,
  URL = 16639,
  URLSearchParams = 16643,
  URLSearchParams_Iterator = 16659,
  UniFFIPointer = 16684,
  UniFFIScaffolding = 16698,
  UserActivation = 16716,
  UserInteraction = 16731,
  UserProximityEvent = 16747,
  VRDisplay = 16766,
  VRDisplayCapabilities = 16776,
  VRDisplayEvent = 16798,
  VREyeParameters = 16813,
  VRFieldOfView = 16829,
  VRFrameData = 16843,
  VRMockController = 16855,
  VRMockDisplay = 16872,
  VRPose = 16886,
  VRServiceTest = 16893,
  VRStageParameters = 16907,
  VTTCue = 16925,
  VTTRegion = 16932,
  ValidityState = 16942,
  VideoColorSpace = 16956,
  VideoDecoder = 16972,
  VideoEncoder = 16985,
  VideoFrame = 16998,
  VideoPlaybackQuality = 17009,
  VideoTrack = 17030,
  VideoTrackList = 17041,
  VisualViewport = 17056,
  WEBGL_color_buffer_float = 17071,
  WEBGL_compressed_texture_astc = 17096,
  WEBGL_compressed_texture_etc = 17126,
  WEBGL_compressed_texture_etc1 = 17155,
  WEBGL_compressed_texture_pvrtc = 17185,
  WEBGL_compressed_texture_s3tc = 17216,
  WEBGL_compressed_texture_s3tc_srgb = 17246,
  WEBGL_debug_renderer_info = 17281,
  WEBGL_debug_shaders = 17307,
  WEBGL_depth_texture = 17327,
  WEBGL_draw_buffers = 17347,
  WEBGL_explicit_present = 17366,
  WEBGL_lose_context = 17389,
  WEBGL_provoking_vertex = 17408,
  WakeLock = 17431,
  WakeLockSentinel = 17440,
  WaveShaperNode = 17457,
  WebExtensionContentScript = 17472,
  WebExtensionPolicy = 17498,
  WebGL2RenderingContext = 17517,
  WebGLActiveInfo = 17540,
  WebGLBuffer = 17556,
  WebGLContextEvent = 17568,
  WebGLFramebuffer = 17586,
  WebGLProgram = 17603,
  WebGLQuery = 17616,
  WebGLRenderbuffer = 17627,
  WebGLRenderingContext = 17645,
  WebGLSampler = 17667,
  WebGLShader = 17680,
  WebGLShaderPrecisionFormat = 17692,
  WebGLSync = 17719,
  WebGLTexture = 17729,
  WebGLTransformFeedback = 17742,
  WebGLUniformLocation = 17765,
  WebGLVertexArrayObject = 17786,
  WebKitCSSMatrix = 17809,
  WebSocket = 17825,
  WebTransport = 17835,
  WebTransportBidirectionalStream = 17848,
  WebTransportDatagramDuplexStream = 17880,
  WebTransportError = 17913,
  WebTransportReceiveStream = 17931,
  WebTransportSendStream = 17957,
  WebrtcGlobalInformation = 17980,
  WheelEvent = 18004,
  Window = 18015,
  WindowClient = 18022,
  WindowContext = 18035,
  WindowGlobalChild = 18049,
  WindowGlobalParent = 18067,
  WindowRoot = 18086,
  Worker = 18097,
  WorkerDebuggerGlobalScope = 18104,
  WorkerGlobalScope = 18130,
  WorkerLocation = 18148,
  WorkerNavigator = 18163,
  WorkerTestUtils = 18179,
  Worklet = 18195,
  WorkletGlobalScope = 18203,
  WritableStream = 18222,
  WritableStreamDefaultController = 18237,
  WritableStreamDefaultWriter = 18269,
  XMLDocument = 18297,
  XMLHttpRequest = 18309,
  XMLHttpRequestEventTarget = 18324,
  XMLHttpRequestUpload = 18350,
  XMLSerializer = 18371,
  XPathEvaluator = 18385,
  XPathExpression = 18400,
  XPathResult = 18416,
  XRBoundedReferenceSpace = 18428,
  XRFrame = 18452,
  XRInputSource = 18460,
  XRInputSourceArray = 18474,
  XRInputSourceEvent = 18493,
  XRInputSourcesChangeEvent = 18512,
  XRPose = 18538,
  XRReferenceSpace = 18545,
  XRReferenceSpaceEvent = 18562,
  XRRenderState = 18584,
  XRRigidTransform = 18598,
  XRSession = 18615,
  XRSessionEvent = 18625,
  XRSpace = 18640,
  XRSystem = 18648,
  XRView = 18657,
  XRViewerPose = 18664,
  XRViewport = 18677,
  XRWebGLLayer = 18688,
  XSLTProcessor = 18701,
  XULCommandEvent = 18715,
  XULElement = 18731,
  XULFrameElement = 18742,
  XULMenuElement = 18758,
  XULPopupElement = 18773,
  XULResizerElement = 18789,
  XULTextElement = 18807,
  XULTreeElement = 18822,
  console = 18837,
  webkitSpeechGrammar = 18845,
  webkitSpeechGrammarList = 18865,
  webkitSpeechRecognition = 18889,
  webkitURL = 18913,
};

namespace binding_detail {
extern const char sBindingNames[];
}  // namespace binding_detail

MOZ_ALWAYS_INLINE const char* BindingName(BindingNamesOffset aOffset) {
  return binding_detail::sBindingNames + static_cast<size_t>(aOffset);
}

} // namespace mozilla::dom


#endif // DOM_BINDINGNAMES_H_
